# Summary

* [Cabbage User Manual](README.md)
* [Beginners (Csound)](csound.md)
    * [File Structure and Syntax](file_structure_and_syntax.md)
    * [Keywords](keywords.md)
    * [Constants and Variables](constants_and_variables.md)
    * [Opcodes](opcodes.md)
    * [Operators and Comments](operators_and_comments.md)
* [Using Cabbage](introduction.md)
    * [Introduction](using_cabbage.md)
    * [Cabbage Syntax](cabbage_syntax.md)
    * [A simple Synthesiser](beginner_synth.md)
    * [A simple Effect](first_effect.md)
    * [The Cabbage patcher](audio_graph.md)
    * [Exporting plugins](exporting.md)
    * [Using plugins in 3rd Party software](cabbage_in_host.md)
    * [Distributing instruments](distributing.md)
* [Features](features.md)
    * [Controlling widgets with Csound](identchannels.html)
    * [Working with sound files](soundfiles.md)
    * [Getting host information into Csound](host_info.md)
    * [Presets](presets.md)
    * [Reserved channels and Macros](macros_and_reserved_channels.md)
    * [Widget arrays](widget_arrays.md)
    * [Managing large numbers of Widgets](managing_large_numbers_of_widgets.md)
    * [Using SVGs](using_svgs.md)
    * [Plants](plants.md)
* [Widget Reference](cabbage_syntax.md)
    * [Button](./Widgets/button.md)
    * [Button(File)](./Widgets/button_file.md)
    * [Button(Info)](./Widgets/button_info.md)
    * [Checkbox](./Widgets/checkbox.md)
    * [Combobox](./Widgets/combobox.md)
    * [Csound Output](./Widgets/csound_output.md)
    * [Endless encoder](./Widgets/encoder.md)
    * [Gentable](./Widgets/gentable.md)
    * [Form](./Widgets/form.md)
    * [Groupbox](./Widgets/groupbox.md)
    * [Hrange](./Widgets/hrange.md)
    * [Image](./Widgets/image.md)
    * [Keyboard](./Widgets/keyboard.md)
    * [Labels](./Widgets/label.md)
    * [Listbox](./Widgets/listbox.md)
    * [Meteres](./Widgets/meter.md)
    * [Numberbox](./Widgets/numberbox.md)
    * [SignalDisplay](./Widgets/signaldisplay.md)
    * [Sliders](./Widgets/sliders.md)
    * [Soundfiler](./Widgets/soundfiler.md)
    * [Textbox](./Widgets/textbox.md)
    * [Texteditor](./Widgets/texteditor.md)
    * [Vrange](./Widgets/vrange.md)
    * [XY Pad](./Widgets/xypad.md)
* [Adding new Widgets](add_new_widgets.md)
    * [Part 1](new_widgets_part_1.md)
    * [Part 2](new_widgets_part_2.md)
    * [Part 3](new_widgets_part_3.md)

